#include <iostream>
#include <cstdio>

using namespace std;
int main()
{
    int N, K;
    scanf("%d%d", &N, &K);
    int a[N][N];
    int i, j, c, pom, pom1=0, pom2;
    int p, q, p1, q1, x, y, pogodne=0;

    for(c=1; c<=K; c++){
        pom=0;
        pom1=0;
        for(i=0; i<N; i++){
            for(j=0; j<N; j++){
                if(c==1)
                    scanf("%d", &a[i][j]);
                if(a[i][j] == c){
                    if(pom == 0){
                        p=i;
                        q=j;
                        pom=1;
                    }
                    p1=i;
                    q1=j;
                    pom1++;
                }
            }
        }
        x = p1-p;
        y = q1-q;
        pom2= 2*x + 2*y;
        if(pom1 == 1)
            pogodne++;
        else if(pom2==pom1)
            pogodne++;
    }
    printf("%d", pogodne);
    return 0;
}